//Henri Cohen in the remarks page 489 - 490. suggests using affine co-ordinates on the Weierstrat equation y^2 = x^3 + ax + b
//and the Montgomery group. E : by^2z = x^3 + ax^2z + xz^2 with b(a^2 − 4) != 0. 
//23-11-2023. Re-visiting this code with the intention of comparing the "inverse" outputs, with the ECC C++ code by 'Jarl Ostensen'
//This website C++ download button "Fusion energy levels / 4D Elliptic Choice"
//Having verified that via < and == for inline via utility header (for c++17 and beyond) I could generate the other comparison
//'operators'. Reviewing "Implementing the ECM of Factoring in Reconfigurable Hardware" by K.Gaj. Et Al 2006 Pages 120-121.
//Seems to indicate the use of "Fast Scalar Multiplication on the clock" Montogomery Ladder. This website button "Prime Ends"
//I Have updated my Computer Setup to handle "Blender" Rendering ect. With a MinGW C++ compiler. 
//Hence this Henri Cohen Parallel Inverse Modulo N C++ code offering. (Obviously a much better Algorithm, is there for the ending)

#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
using namespace std;

int Euclid_Extended_1_3_6(int a, int b, int& u, int& v) {
    bool valid1{}; //so is false
    int v1 = 0;
    int v3 = 0;
    int t1 = 0;
    int t3 = 0;
    int d = a;
    int q = 0;
    if (b == 0) {
        v = 0;
        cout << " b = 0 Terminated Alg : Choose b > 0 " << endl;
        valid1 = true;
    }
    else {
        v3 = b;
    }
    //Step 2
    do {
        if (v3 == 0) {
            v = ((d - (a * u)) / b); // This Eq req exact see H.Cohen 1.3.6 remarks
            valid1 = true;
            return d;
        }
        //Step 3
        q = (d / v3);  // These 2 Eq req Simultaneous resolution see H.Cohen 1.3.6 remarks
        t3 = (d % v3);     // These 2 Eq req Simultaneous resolution see H.Cohen 1.3.6 remarks
        t1 = (u - q * v1);
        u = v1;
        d = v3;
        v1 = t1;
        v3 = t3;
    } while (valid1 == false);
}

int Parallel_Inverse_Mod_N(int N) {
//Step 1 Initialise  //
    int Basek[4] = { 2,5,6,13 };
    vector<int>Vc;
    int bi = 0;
    int Ci = Basek[0];
    int Cia = Basek[0];
    int ki = Basek[3];
    int Cib = N; //17
    int Ciu = 5;  // 5  ...1
    int Civ = 16; // 16  ...0
    int Ciu1 = 5;  //Repeat of Ciu
    int Civ1 = 16; //Repeat of Civ
    int DCi = 0;
    int DCai = 0;
    
    for (Ci; Ci < ki; Ci++) {
        Vc.push_back((Ci - 1) * (Ci % N));
        cout << "  Vc = " << (Ci - 1) * (Ci % N) << endl;
    }
    DCi = Euclid_Extended_1_3_6(Cia, Cib, Ciu, Civ);
    cout << "  DCi = " << DCi <<endl;
    if (DCi == 1) {
        for (int i = (ki - 3); i >= 0; i--) {   //Req Fix via sizeof(ki)
            bi = ((Ciu1 * Vc[i]) % N);
            cout << "  Inverse = " << bi << endl;
            Ciu1 = ((Ciu1 * i) % N);
            if (i == 0) {
                bi = Ciu1;
                cout << "  Inverse = " << bi << endl;
            }
        }
    }
    else{
        if (DCi == N) {
            for (int ai = 0; ai < ki; ai++) {
                DCai = Euclid_Extended_1_3_6(ai, N, Ciu, Civ);
                if (DCai > 1) {
                    cout << "  'd' A non trivial factor = " << DCai << endl;
                }
            }
        }
    }
    return 0;
}

int main() {
    int N = 0;
    cout << " Parallel Inverse Mod N  " << endl;
    cout << " y^2 = x^3 + ax + b  or  y^2 = x^3 + x + 1 mod N " << endl;
    cin >> N;
    Parallel_Inverse_Mod_N(N);
}